summaryrefslogtreecommitdiff
path: root/t/test-trs-recover2.sh
diff options
context:
space:
mode:
authorStefano Lattarini <stefano.lattarini@gmail.com>2012-04-11 16:35:09 +0200
committerStefano Lattarini <stefano.lattarini@gmail.com>2012-04-11 17:34:02 +0200
commit1490961b7bfcb4a5bba24925ff45e2ff32fa93f0 (patch)
treedde3c73b3665af9a666b920fe6c59a6fdf8b9333 /t/test-trs-recover2.sh
parent5edc5fc4b997d2748967a054638ca0190f10be51 (diff)
parente306fb5d1043c60b46128fb09ee54434340a0d42 (diff)
downloadautomake-1490961b7bfcb4a5bba24925ff45e2ff32fa93f0.tar.gz
Merge branch 'master' into ng/master
* master: vala tests: force the use of automatic dependency tracking tests: avoid spurious failures in tests on C++ and lex tests: avoid spurious failures with non-flex 'lex' programs and C++ tests: avoid a spurious failures for shells with busted 'set -e' maint: simplify generation of files with @substed@ stuff tests: remove redundant requirement tests: make two test scripts executable t/README: update w.r.t. recent overhaul (non-recursive build system) docs: fix names of relevant test cases in comments NEWS: automake build systems avoids make recursion maint: no more make recursion in Automake's build system tests: rename 'tests/' => 't/', '*.test' => '*.sh' tests: remove recipes that run tests with 'prove' tests: move most helper scripts and files into the 'ax' subdirectory maint: remove most recursion in automake's own build system tests: fix a spurious failures with non-GNU make + Extra non-trivial edits: * Makefile.am: Remove new uses of 'AM_MAKEFLAGS' throughout. (dist_automake_ac_DATA): Do not list 'm4/depout.m4' nor 'm4/make.m4'. * syntax-checks.m4: Use '$(xdefs)' instead of hard-coding the older paths of 'defs' and 'defs-static.in'. Use 't/README' instead of 'tests/README'. * t/instdir-no-empty.sh: Remove uses of 'AM_MAKEFLAGS'. * tests/depcomp-recover.test: Renamed ... * t/depcomp-recover.sh: ... to this. * tests/gmake-vars.test: Renamed ... * t/gmake-vars.sh: ... to this. * tests/interp3.test: Renamed ... * t/interp3.sh: ... to this. * tests/objdir.test: Renamed ... * t/objdir.sh: ... to this. * tests/spy-vpath-rewrite.test: Renamed ... * t/spy-vpath-rewrite.sh: ... to this. * tests/vpath-rewrite.test: Renamed ... * t/vpath-rewrite.sh: ... to this. * tests/yacc-subobj-nodep.test: Renamed ... * t/yacc-subobj-nodep.sh: ... to this. * tests/depcomp-shuffle.sh: Renamed ... * t/ax/depcomp-shuffle.sh: ... to this, and removed executable bit. * t/depcomp-shuffle-sub-vpath.sh: Adjust. * t/depcomp-shuffle-sub.sh: Likewise. * t/depcomp-shuffle-vpath.sh: Likewise. * t/depcomp-shuffle.sh: Likewise. * gen-testsuite-part: Likewise. * t/list-of-tests.mk: Do not list tests that had been already removed from the Automake-NG testsuite. Take into account the renames above. Signed-off-by: Stefano Lattarini <stefano.lattarini@gmail.com>
Diffstat (limited to 't/test-trs-recover2.sh')
-rwxr-xr-xt/test-trs-recover2.sh133
1 files changed, 133 insertions, 0 deletions
diff --git a/t/test-trs-recover2.sh b/t/test-trs-recover2.sh
new file mode 100755
index 000000000..ba5974303
--- /dev/null
+++ b/t/test-trs-recover2.sh
@@ -0,0 +1,133 @@
+#! /bin/sh
+# Copyright (C) 2011-2012 Free Software Foundation, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+# Check parallel harness features:
+# - recovery from unreadable '.trs' files, in various scenarios
+
+am_parallel_tests=yes
+. ./defs || Exit 1
+
+cat >> configure.ac <<END
+AC_OUTPUT
+END
+
+cat > Makefile.am << 'END'
+TESTS = foo.test bar.test
+TEST_LOG_COMPILER = true
+END
+
+: > foo.test
+: > bar.test
+
+TEST_STATUS=0; export TEST_STATUS
+
+$ACLOCAL
+$AUTOCONF
+$AUTOMAKE -a
+
+./configure
+
+: > t
+chmod a-r t
+test ! -r t || Exit 77
+rm -f t
+
+: Create the required log files.
+$MAKE check
+test -f foo.trs
+test -f bar.trs
+
+: Recreate with a sweeping "make check".
+chmod a-r bar.trs
+$MAKE check
+test -f foo.trs
+test -r foo.trs
+test -f bar.trs
+test -r bar.trs
+
+: Again, this time with one .trs file missing and the other
+: one unreadable.
+rm -f foo.trs
+chmod a-r bar.trs
+$MAKE check
+test -f foo.trs
+test -r foo.trs
+test -f bar.trs
+test -r bar.trs
+
+: Again, but using "make recheck" this time.
+rm -f foo.trs
+chmod a-r bar.trs
+$MAKE recheck >stdout || { cat stdout; Exit 1; }
+cat stdout
+test -f foo.trs
+test -r foo.trs
+test -f bar.trs
+test -r bar.trs
+grep '^PASS: foo\.test' stdout
+grep '^PASS: bar\.test' stdout
+
+: More complex interactions with "make recheck" are OK.
+chmod a-r bar.log bar.trs
+$MAKE recheck >stdout || { cat stdout; Exit 1; }
+cat stdout
+test -f bar.trs
+test -r bar.trs
+grep '^PASS: bar\.test' stdout
+grep 'foo\.test' stdout && Exit 1
+count_test_results total=1 pass=1 fail=0 xpass=0 xfail=0 skip=0 error=0
+
+: Recreate by remaking the global test log.
+chmod a-r foo.trs
+rm -f test-suite.log
+$MAKE test-suite.log >stdout || { cat stdout; Exit 1; }
+cat stdout
+test -f foo.trs
+test -r foo.trs
+grep '^PASS: foo\.test' stdout
+grep 'bar\.test' stdout && Exit 1
+# Also test that have only run before should be counted in the final
+# testsuite summary.
+grep '^# TOTAL: *2$' stdout
+
+: Setup for the next check.
+: > baz.test
+sed 's/^TESTS =.*/& baz.test/' Makefile > t
+diff t Makefile && Exit 99
+mv -f t Makefile
+$MAKE check
+test -f foo.trs
+test -f bar.trs
+test -f baz.trs
+
+: Interactions with lazy test reruns are OK.
+chmod a-r foo.trs
+$sleep
+touch stamp
+$sleep
+touch bar.test
+$MAKE RECHECK_LOGS= check >stdout || { cat stdout; Exit 1; }
+cat stdout
+test -r foo.trs
+is_newest bar.trs bar.test
+grep '^PASS: foo\.test' stdout
+grep '^PASS: bar\.test' stdout
+grep 'baz\.test' stdout && Exit 1
+# Also test that have only run before should be counted in the final
+# testsuite summary.
+grep '^# TOTAL: *3$' stdout
+
+: